#include "app.h"
#include "input.h"
#include "graphics.h"
#include "texturemanager.h"
#include "draw.h"
#include "colour.h"

App::App()
{
};

App::~App()
{
};

bool App::Init()
{
	new Log();
	new Input();
	new Graphics();
	new TextureManager();

	Graphics::GetSingleton().Init(800, 600, 24, SDL_OPENGL | SDL_GL_DOUBLEBUFFER | SDL_HWPALETTE, "S4");
	Graphics::GetSingleton().MakeWindow();
	Graphics::GetSingleton().SetMode(PROJECTION);
	Input::GetSingleton().Start();

	level = new Level();

	return true;
};

void App::Run()
{
	while(1)
	{
		if(SDL_QuitRequested() != 0)
			break;

		if(Input::GetSingleton().keyDown(SDLK_ESCAPE) == true)
			break;

		Input::GetSingleton().Update();
		if(Input::GetSingleton().keyDown(SDLK_RETURN) == true)
			ForceManager::GetSingleton().AddForce(Vector(400, 300, 0), 30, fUp);

		if(Input::GetSingleton().keyDown(SDLK_c) == true)
		{
			ForceManager::GetSingleton().ClearAllForces();
			PortalManager::GetSingleton().ClearAllPortals();
		}

		if(Input::GetSingleton().keyDown(SDLK_SPACE) == true)
			PortalManager::GetSingleton().AddPortal(Vector(400, 300, 0), 30, WHITE);

		level->Update();

		Graphics::GetSingleton().ClearScreen();


		//emitter->Emit(100 * dt);
		//emitter->Update(dt);
		Graphics::GetSingleton().SetMode(ORTHOGRAPHIC);

		level->Render();

		Graphics::GetSingleton().SetMode(END_2D);
		Graphics::GetSingleton().SwapBuffers();

	}
};

bool App::Shutdown()
{
	delete level;
	delete TextureManager::GetSingletonPtr();
	delete Graphics::GetSingletonPtr();
	delete Input::GetSingletonPtr();
	return true;
};
