#ifndef DRAW_H_
#define DRAW_H_

#include "globals.h"
#include "cvector.h"
#include "colour.h"
#include "texture.h"

#ifdef __cplusplus
extern "C" {
#endif

#define GL_Y_FIX(f) (1 - (f))

enum RECT_TYPES
{
	LINE = 0,
	TEX,
	TEX_WLINE,
};

void DrawLine(const Vector &v1, const Vector &v2, Colour colour);
void DrawLineRect(const Vector &v1,int width, int height, Colour colour);
void DrawRect(int x, int y, int width, int height, Colour colour);
void DrawTex(const Vector &v1, float width, float height, const Texture2D &tex,
	Colour colour = Colour(255,255,255,255), bool aspect = true, float scale = 1, float rotate = 0);
//void DrawTexFBO(const Vector &v1, float width, float height, RenderFBO *FBO,
//	Colour colour, bool aspect);
void DrawLineCirle(Vector pos, int radius, Colour colour);
void DrawCircle(Vector pos, int radius, Colour colour);
#ifdef __cplusplus
};
#endif //__cplusplus

#endif
