#ifndef EMITTER_H_
#define EMITTER_H_

#include "particlesystem.h"
#include "force.h"
#include "portal.h"

class Emitter : public ParticleSystem
{
public:
	Emitter(int maxParticles, float life, int emitRadius, const Vector &origin, float angle, int velocity);
	~Emitter();
	void UpdatePos(Vector &origin, Vector &emitDir);
	void Update(float timems);
	void Render(bool reflect);
	void LoadTexture(std::string filename);
	bool isActive() const { return m_active; }
	void SetActive(bool active) { m_active = active; }
	int Emit(float numParticles);
	void ProcessInput();

private:
	void RenderGUI();
	float m_emitAngle;
	int m_velocity;
	Vector m_emitDir;
	float m_emit;
	bool m_active;
	int m_emitRadius;
protected:
	void InitParticle(Particle &p);
};

#endif
