#ifndef FORCE_H_
#define FORCE_H_

#include "globals.h"
#include "cvector.h"
#include "texture.h"
#define MAX_FORCE 4
enum FORCE_LIST
{
	fUp = 0,
	fDown,
	fRight,
	fLeft,
};

class Force
{
public:
	Force(Vector pos, int radius, int Enum);
	~Force();

	void Update();
	void Render();
	void SetActive(bool active);
	bool isActive() { return m_active; }
	Vector GetForce() const { return m_force; }
	Vector GetPosition() const { return m_position; }
	int GetType() const { return m_type; }
	int GetRadius() const { return m_radius; }
private:
	void SetType(int Enum);
	Vector m_position;
	Vector m_force;
	bool m_active;
	int m_type;
	int m_radius;
};

class ForceManager : public Singleton<ForceManager>
{
public:
	ForceManager();
	~ForceManager();

	void AddForce(Vector pos, int radius, int type);
	Force *GetForces(int index) const { return m_forces[index]; }
	int GetForcesSize() const {return m_forces.size(); }
	void Update();
	void Render();
	void ClearAllForces();
	bool isActive() const { return m_active; }
private:
	std::vector<Force *> m_forces;
	int m_ActiveForce;
	int oldMouseX, oldMouseY;
	Texture2D *m_dir;
	bool m_active;
};

#endif // FORCE_H_
