#include "gmath.h"
#include <math.h>
#include "cvector.h"


float GetDistance(float x1, float y1, float x2, float y2)
{
	float x = (x1 - x2);
	float y = (y1 - y2);

	x *= x;
	y *= y;

	return sqrt(x + y);
};

double GetVectorAngle(Vector v1, Vector v2, Vector p)
{

};

float GetDistanceV(Vector vector1, Vector vector2)
{
	float x = (vector1.x - vector2.x);
	float y = (vector1.y - vector2.y);
	float z = (vector1.z - vector2.z);

	x *= x;
	y *= y;
	z *= z;

	float rtn = (x + y + z);

	return (rtn == 0) ? 0 : sqrt(rtn);
};

float DegreesToRedians(float degrees)
{
	return (degrees * PI) / 180.0f;
};

float RadiansToDegrees(float radians)
{
	return (radians * 180.0f) / PI;
};

Vector ConvertToWorld(GLfloat winX, GLfloat winY, Vector *near, Vector *far, Vector *dir)
{
	Vector result;

	GLdouble rx, ry, rz;
	GLdouble nx, ny, nz;
	GLdouble fx, fy, fz;

	GLfloat winZ;

	GLint viewport[4];
	GLdouble modelview[16];
	GLdouble projection[16];

	glGetIntegerv(GL_VIEWPORT, viewport);
	glGetDoublev(GL_MODELVIEW_MATRIX, modelview);
	glGetDoublev(GL_PROJECTION_MATRIX, projection);

	winY = viewport[3] - winY;
	glReadPixels((int)winX, (int)winY, 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, &winZ);

	gluUnProject(winX, winY, winZ, modelview, projection, viewport, &rx, &ry, &rz);

	result.set(rx, ry , rz);
	if((near == NULL) || (far == NULL) || (dir == NULL))
		return result;

	gluUnProject(winX, winY, 0.0, modelview, projection, viewport, &nx, &ny, &nz);
	gluUnProject(winX, winY, 1.0, modelview, projection, viewport, &fx, &fy, &fz);

	near->set(nx, ny, nz);
	far->set(fx, fy, fz);

	*dir = *far;
	*dir -= *near;
	dir->Normalize();

	return result;
};

double GetPlaneDistance(Vector normal, Vector point)
{
	return (dotProd(normal, point) * -1);
};

Vector AngleToVector(float angle, int radius, int num)
{
	Vector ret;
	float x, y, x1, y1;
	x = (float)(sin((double)DegreesToRedians(angle)) * (double)radius);
	y = (float)(cos((double)DegreesToRedians(angle)) * (double)radius);

	if(x < 0)
		x1 = -x;
	else if(x >= 0)
		x1 = x;

	if(y < 0)
		y1 = -y;
	else if(y >= 0)
		y1 = y;

	double div = (double)(num / (x1 + y1));
	ret.x = (float)(div * (double)x);
	ret.y = (float)(div * (double)y);
	ret.z = 0;

	return ret;
};

Vector GetVectorFromPoint(Vector v1, Vector v2)
{
	v1.x = v1.x - v2.x;
	v1.y = v1.y - v2.y;
	v1.z = v1.z - v2.z;
	return v1;
};
