#ifndef GMATH_H_
#define GMATH_H_

#include "cvector.h"
#include "globals.h"
#ifdef __cplusplus
extern "C" {
#endif


const float PI = 3.1415926f;
const float HALF_PI = PI / 2.0f;
const float EPSILON = 1e-6f;

double GetVectorAngle(Vector v1, Vector v2, Vector p);

float GetDistance(float x1, float y1, float x2, float y2);

float GetDistanceV(Vector vector1, Vector vector2);

float DegreesToRedians(float degrees);

float RadiansToDegrees(float radians);

Vector ConvertToWorld(GLfloat winX, GLfloat winY, Vector *near, Vector *far, Vector *dir);

Vector GetVectorFromPoint(Vector v1, Vector v2);
double GetPlaneDistance(Vector normal, Vector point);
Vector AngleToVector(float angle, int radius, int num);
#ifdef __cplusplus
}
#endif

#endif // GMATH_H_
