#include "globals.h"
#include "cvector.h"

enum Modes
{
	NO_MODE = 0,
	ORTHOGRAPHIC,
	PROJECTION,
	END_2D,
};

class Graphics : public Singleton<Graphics>
{
public:
	Graphics();
	~Graphics();

	bool Init(int width, int height, int bpp, Uint32 SDL_flags, std::string WindowName);
	void Shutdown();

	void ClearScreen();
	void SwapBuffers();

	bool MakeWindow();

	void ResizeWindow(int width, int height);

	void ToggleFullscreen();
	int ScreenShot();
	int GetWidth();
	int GetHeight();
	Vector convertToWorldCoords(GLfloat winX, GLfloat winY, Vector *near, Vector *far, Vector *dir);
	void SetMode(int mode);
	GLfloat GetRatio();
	int GetMode();
private:
	GLint viewport[4];
	GLdouble modelview[16];
	GLdouble projection[16];
protected:
	void InitGL();
	time_t date;
	bool m_loaded;

	int m_width;
	int m_height;
	int m_bpp;
	std::string m_windowName;
	bool m_fullscreen;

	int m_renderMode;

	SDL_Surface *m_screen;

	Uint32 m_SDL_flags;
};
