#ifndef INPUT_H_
#define INPUT_H_

#include "globals.h"

struct Mouse
{
	int dx, dy;
	int oldX, oldY;
	unsigned int buttons;
	unsigned int oldButtons;
};

struct Keyboard
{
	unsigned char *keys;
	unsigned char *oldKeys;
	int keycount;
};

class Input : public Singleton<Input>
{
public:
	Input();
	~Input();

	bool Start();
	void Update();

	bool inline curKey(int index) { return (keyboard.keys[index]!=0); }
	bool inline oldKey(int index) { return (keyboard.oldKeys[index]!=0); }
	int inline GetX() { return mouse.dx; }
	int inline GetY() { return mouse.dy; }
	int inline GetOldX() { return mouse.oldX;}
	int inline GetOldY() { return mouse.oldY;}
	bool inline keyDown(int index) { return ( curKey(index))&&(!oldKey(index)); }
	bool inline keyStillDown(int index) { return ( curKey(index))&&( oldKey(index)); }
	bool inline keyUp(int index) { return (!curKey(index))&&( oldKey(index)); }
	bool inline keyStillUp(int index) { return (!curKey(index))&&(!oldKey(index)); }

	bool inline curMouse(int button) { return (mouse.buttons&SDL_BUTTON(button))!=0; }
	bool inline oldMouse(int button) { return (mouse.oldButtons&SDL_BUTTON(button))!=0; }

	bool inline mouseDown(int button)	{ return ( curMouse(button))&&(!oldMouse(button)); }
	bool inline mouseStillDown(int button)	{ return ( curMouse(button))&&( oldMouse(button)); }
	bool inline mouseUp(int button)		{ return (!curMouse(button))&&( oldMouse(button)); }
	bool inline mouseStillUp(int button)	{ return (!curMouse(button))&&(!oldMouse(button)); }
private:
	int keycount;
	Keyboard keyboard;
	Mouse mouse;
	SDL_Event *event;
};


#endif
