#include "level.h"

Level::Level()
{
	new ForceManager();
	new PortalManager();
	m_stream = new Emitter(1000, 5, 30, Vector(30,20,-0), 0, 200);
	m_stream->LoadTexture("particle.png");
	m_stream->StartEmitting();
	MainTimer = new Timer();
};

Level::~Level()
{
	delete ForceManager::GetSingletonPtr();
	delete PortalManager::GetSingletonPtr();
	delete m_stream;
};

void Level::Update()
{
	MainTimer->Update();
	if(m_active_man == -1)
	{
		ForceManager::GetSingleton().Update();
		PortalManager::GetSingleton().Update();
		m_stream->ProcessInput();
	}

	if(PortalManager::GetSingleton().isActive() == true)
	{
		m_active_man = PORTAL_MAN;
	}
	else if(ForceManager::GetSingleton().isActive() == true)
	{
		m_active_man = FORCE_MAN;
	}
	else if(m_stream->isActive() == true)
	{
		m_active_man = EMITTER_MAN;
	}

	m_stream->Emit(100 * MainTimer->GetDT());
	m_stream->Update(MainTimer->GetDT());

	if(m_active_man != -1)
	{
		switch(m_active_man)
		{
			case FORCE_MAN:
				ForceManager::GetSingleton().Update();
				if(ForceManager::GetSingleton().isActive() == false)
					m_active_man = -1;
			break;
			case PORTAL_MAN:
				PortalManager::GetSingleton().Update();
				if(PortalManager::GetSingleton().isActive() == false)
					m_active_man = -1;
			break;
			case EMITTER_MAN:
				m_stream->ProcessInput();
				if(m_stream->isActive() == false)
					m_active_man = -1;
			break;
		}
	}
};

void Level::Render()
{
	m_stream->Render(false);
	ForceManager::GetSingleton().Render();
	PortalManager::GetSingleton().Render();
};

void Level::AddForce(Vector pos, int radius, int type)
{
	ForceManager::GetSingleton().AddForce(pos, radius, type);
};

void Level::AddPortal(Vector pos, int radius, int colour)
{
	PortalManager::GetSingleton().AddPortal(pos, radius, colour);
};
