#include "log.h"
#include "globals.h"

Log::Log()
{
	Init();
};

Log::~Log()
{
	appLog.close();
	clientLog.close();
	serverLog.close();
};

bool Log::Init()
{
	appLog.open("app.log");
	clientLog.open("client.log");
	serverLog.open("server.log");

	return true;
};

void Log::Write(int target, const char *msg, ...)
{
	va_list args; va_start(args, msg);
	char buffer[1024];

	vsprintf(buffer, msg, args);
	if(target & LOG_APP)
	{
		appLog << buffer << "\n";
		appLog.flush();
	}
	if(target & LOG_CLIENT)
	{
		clientLog << buffer << "\n";
		clientLog.flush();
	}
	if(target & LOG_SERVER)
	{
		serverLog << buffer << "\n";
		serverLog.flush();
	}
	if(target & LOG_USER)
	{
#ifdef WIN32
		MessageBox(NULL, buffer, "Message", MB_OK);
#else
		printf("User-level logging not yet implamented on this OS\n");
#endif
	}
};

