#ifndef LOG_H_
#define LOG_H_

#include <iostream>
#include <fstream>
#include <sstream>
#include "globals.h"

enum LOG_TYPE
{
	LOG_APP = 1,
	LOG_CLIENT,
	LOG_SERVER = 4,
	LOG_USER = 8
};

#define MAX_LOG_STRINGS 256

class Log : public Singleton<Log>
{
public:
	Log();
	virtual ~Log();
	void Write(int target, const char *msg, ...);
protected:
	bool Init();
	std::ofstream appLog;
	std::ofstream clientLog;
	std::ofstream serverLog;

	std::string logString[MAX_LOG_STRINGS];
	bool LoadStrings();
};

#endif
