#ifndef SINGLETON_H_
#define SINGLETON_H_

// template<class T>

///singleton class
template<typename T>
class Singleton
{
public:
	/// Get a pointer to the singelton
	static inline T &GetSingleton()
	{
// 		 T m_Instance;
		return *m_Instance;
	}
	static inline T *GetSingletonPtr()
	{
// 		static T m_Instance;
		return m_Instance;
	}


	Singleton()
	{
		int offset = (int*)(T*)1 - (int*)(Singleton <T>*)(T*)1;
		m_Instance = (T*)(this + offset);
	}
	~Singleton()
	{
		m_Instance = 0;
	}
// 	Singleton(Singleton const&);
// 	Singleton &operator=(Singleton const&);
	static T *m_Instance;
};

template <typename T> T* Singleton<T>::m_Instance = 0;
/*
class Singleton
{
public:
	/// Get a pointer to the singelton
	static T *GetSinglePtr()
	{
		static T m_Instance;
		return &m_Instance;
	}

private:
	Singleton();
	~Singleton();
	Singleton(Singleton const&);
	Singleton &operator=(Singleton const&);
};
*/



#endif
