#ifndef TEXTURE_MANAGER_H_
#define TEXTURE_MANAGER_H_

#include "texture.h"
#include "globals.h"
#include "singleton.h"

///Texture Manager class

class TextureManager : public Singleton<TextureManager>
{
public:
	TextureManager();
	~TextureManager();

	Texture2D *Load(const std::string &filename);
	Texture2D *Load(unsigned char *pixels);
	void RegisterTexture(const std::string &name, Texture2D *object)
		throw(std::runtime_error);
	void UnRegisterTexture(const std::string &name, bool deleteTex = false);

	void DeleteAllTextures();
private:
	Texture2D *getTex(const std::string &name);
	std::map<std::string, Texture2D *> m_texMap;

};

#endif
